program CRTTBL;
{$apptype console}

{ use FTP to get a translation table EBCDIC <-> ANSI }

uses
 Windows,CrtSock;

Type
 TBL=array[0..255] of byte;

var
 Host:string;
 Server:integer;
 sin,sout:TextFile;
 s:string;
 p:integer;
 port:word;
 data:integer;

 ansi,ebcdic:TBL;

 f:file of TBL;

procedure WriteString(s:string);
 begin
  WriteLn('>>>',s);
  WriteLn(sout,s);
 end;

function ReadString:string;
 begin
  Repeat
   ReadLn(sin,result);
   WriteLn(result);
  until (length(Result)<4) or (Result[4]<>'-');
  if result='' then Result:='?';
 end;

function Echo(s:string):string;
 begin
  WriteString(s);
  Result:=ReadString;
 end;

function Status:char;
 begin
  Status:=ReadString[1];
 end;

function Exec(s:string):char;
 begin
  WriteString(s);
  Result:=Status;
 end;

function GetValue:integer;
 var
  x:integer;
  m:integer;
 begin
  m:=1;
  result:=0;
  x:=Length(s);
  while s[x]<>',' do begin
   Result:=Result+m*(ord(s[x])-ord('0'));
   m:=10*m;
   dec(x);
  end;
  SetLength(s,x-1);
 end;

function Trim(s:string):string;
 begin
  while (s<>'')and(s[1]=' ') do delete(s,1,1);
  while (s<>'')and(s[length(s)]=' ') do delete(s,length(s),1);
  Result:=s;
 end;

procedure UpDown;
 begin
  AssignCrtsock(Server,sin,sout);
  if Status<>'2' then exit;

  Write('Enter a valid AS/400 username : '); ReadLn(s);
  if Exec('USER '+s)<>'3' then exit;
  Write('Enter password for ',s,' : '); ReadLn(s);
  if Exec('PASS '+s)<>'2' then exit;

  if Exec('TYPE I')<>'2' then exit;
  s:=Echo('PASV'); if s[1]<>'2' then exit;
  s:=Trim(Copy(s,5,Length(s))); // ip,port
  p:=pos('(',s); if p>0 then s:=Copy(s,p+1,length(s)); SetLength(s,pos(')',s)-1);
  p:=GetValue; Port:=256*GetValue+p; // get Port
  for p:=1 to Length(s) do if s[p]=',' then s[p]:='.'; // replace "," by "." in IP address
  WriteString('STOR QTEMP/TABLE');
  Data:=CallServer(s,port);
  if Data=-1 then exit;
  if Status<>'1' then exit;
  Send(Data,Ansi,sizeOf(Ansi),0);
  Disconnect(Data);
  if Status<>'2' then exit;

  if Exec('TYPE A')<>'2' then exit;
  s:=Echo('PASV'); if s[1]<>'2' then exit;
  s:=Trim(Copy(s,5,Length(s))); // ip,port
  p:=pos('(',s); if p>0 then s:=Copy(s,p+1,length(s)); SetLength(s,pos(')',s)-1);
  p:=GetValue; Port:=256*GetValue+p; // get Port
  for p:=1 to Length(s) do if s[p]=',' then s[p]:='.'; // replace "," by "." in IP address
  WriteString('RETR QTEMP/TABLE');
  Data:=CallServer(s,port);
  if Data=-1 then exit;
  if Status<>'1' then exit;
  p:=0;
  repeat
   inc(p,Recv(Data,@Ansi[p],SizeOf(Ansi),0));
  until p=SizeOf(Ansi);
  Disconnect(Data);
  if Status<>'2' then exit;

  for p:=0 to 255 do Ebcdic[Ansi[p]]:=p;

  AssignFile(f,'TN400.TBL');
  Rewrite(f);
  write(f,Ansi);
  write(f,Ebcdic);
  CloseFile(f);

 end;

begin
 Writeln('This program try to create valid translation tables for your AS/400');
 WriteLn('1- upload in a binary file with code from 0 to 255');
 WriteLn('2- download the file in a ascii mode to get the translated codes');

 for p:=0 to 255 do ansi[p]:=p;

 Write('Enter the name of your AS/400 : '); ReadLn(Host);
 Writeln('Contacting ',Host,' for FTP connection...');
 Server:=CallServer(Host,21);
 if Server=-1 then
  WriteLn('Host not found or FTP not ready.')
 else begin
  UpDown;
  Exec('QUIT');
  Disconnect(Server);
 end;
 WriteLn('---press enter---');
 ReadLn;
end.
